Skip to main content

3SUM - Hard


Problem - Given an Array of integers, A. Find out if there exists a triple (i,j,k) such that A[i] + A[j] + A[k] == 0.
The 3SUM problem is very similar to the 2SUM problem in many aspects. The solutions I'll be discussing are also very similar. I highly recommend you read the previous post first, since I'll explain only the differences in the algorithm from the previous post.

Let's begin, We start with the naive algorithm. An O(n^3) solution with 3 nested loops each checking if the sum of the triple is 0. Since O(n^3) is the higher order term, we can sort the array in O(nlogn) and add a guard at the nested loops to prune of parts of the arrays. But the complexity still remains O(n^3).

The code is pretty simple and similar to the naive algorithm of 2SUM.


// Complexity - O(n^3)
private int[] findTriple_1(int[] A) {
Arrays.sort(A); // O(nlogn)
for (int i = 0, l = A.length; i < l && A[i] < 0; i++) {
for (int j = i + 1; j < l && A[i] + A[j] < 0; j++) {
for (int k = j + 1; k < l; k++) {
int s = A[i] + A[j] + A[k];
if (s > 0) break;
if (s == 0) return new int[]{A[i], A[j], A[k]};
}
}
}
return null;
}
view raw ThreeSum.java hosted with ❤ by GitHub
Moving on, we'll do the same thing we did in 2SUM, replace the inner-most linear search with a binary search. The Complexity now drops to O(n^2 logn)


// Complexity - O(n^2 logn)
private int[] findTriple_2(int[] A) {
Arrays.sort(A); // O(nlogn)
for (int i = 0, l = A.length; i < l && A[i] < 0; i++) { //O(n^2 logn)
for (int j = i + 1; j < l && A[i] + A[j] < 0; j++) {
int k = Arrays.binarySearch(A, j + 1, l, -A[i] - A[j]);
if (k > j) return new int[]{A[i], A[j], A[k]};
}
}
return null;
}
view raw ThreeSum.java hosted with ❤ by GitHub
Now, the hash table method, this is strictly not the same as the previous problem, here we have to store the pair associated with the sum, hence I switch to a HashMap instead of a set. Also we need to store the pairs for each i and clear the map when we pick a new starting element.

// Complexity - O(n^2), Space Complexity - O(n^2)
private int[] findTriple_3(int[] A) {
Map<Integer, int[]> map = new HashMap<Integer, int[]>();
for (int i = 0, l = A.length; i < l; i++) {
map.clear();
for (int j = i + 1; j < l; j++) {
if (map.containsKey(A[j])) {
int[] pair = map.get(A[j]);
return new int[]{pair[0], pair[1], A[j]};
} else
map.put(-A[i] - A[j], new int[]{A[i], A[j]});
}
}
return null;
}
view raw ThreeSum.java hosted with ❤ by GitHub

 Note. This time we don't need the array to sorted. We can do it ourselves, since our overall complexity is going to be O(n^2), a sort call will only cost us O(nlogn) which is a lower order term.

And now finally, we're going to use the left-right method (for lack of a better name).This time we keep one element as a constant and then for each element A[i], we run the 2SUM Linear Algorithm for A[i+1...n] That gives us a O(n^2) algorithm.


// Complexity - O(n^2)
private int[] findTriple_4(int[] A) {
Arrays.sort(A);
for (int i = 0,l = A.length; i < l; i++) {
int left = i + 1, right = l - 1;
while (left < right) {
int s = A[i] + A[left] + A[right];
if (s == 0)
return new int[]{A[i],A[left], A[right]};
else if (s > 0)
right--;
else
left++;
}
}
return null;
}
view raw ThreeSum.java hosted with ❤ by GitHub
The Entire source code can be found here.

Comments

Popular posts from this blog

Find Increasing Triplet Subsequence - Medium

Problem - Given an integer array A[1..n], find an instance of i,j,k where 0 < i < j < k <= n and A[i] < A[j] < A[k]. Let's start with the obvious solution, bruteforce every three element combination until we find a solution. Let's try to reduce this by searching left and right for each element, we search left for an element smaller than the current one, towards the right an element greater than the current one. When we find an element that has both such elements, we found the solution. The complexity of this solution is O(n^2). To reduce this even further, One can simply apply the longest increasing subsequence algorithm and break when we get an LIS of length 3. But the best algorithm that can find an LIS is O(nlogn) with O( n ) space . An O(nlogn) algorithm seems like an overkill! Can this be done in linear time? The Algorithm: We iterate over the array and keep track of two things. The minimum value iterated over (min) The minimum increa...

Find the Quadruplets - Hard

Problem - Given 4 arrays A,B,C,D. Find out if there exists an instance where A[i] + B[j] + C[k] + D[l] = 0 Like the Find the Triple problem, we're going to develop 4 algorithms to solve this. Starting with the naive O(n^4) solution. Then we proceed to eliminate the inner-most loop with a Binary Search, reducing the complexity to O(n^3 logn) Now, we replace the last 2 loops with the left-right traversal we did in the previous 3 posts. Now the complexity is O(n^3). Finally, we reduce the complexity to O(n^2 logn) at the cost of O(n^2) Space Complexity. We store every combination of A[i] + B[j] and store it in AB[]. Similarly we make CD[] out of C[i] + D[j]. So, AB = A x B CD = C x D We then sort AB and CD (which costs O(n^2 log(n^2)) ~ O(n^2 logn) ) and then run a left-right linear Algorithm on AB and CD. (Note : Their size is of the order O(n^2)) So the overall complexity is due to sorting the large array of size n^2. which is O(n^2 logn).

Dijkstra's algorithm - Part 1 - Tutorial

This will be a 3 Part series of posts where I will be implementing the Dijkstra's Shortest Path algorithm in Python. The three parts will be 1) Representing the Graph 2) Priority Queue 3) The Algorithm To represent a graph we'll be using an  Adjacency List . Another alternative is using an Adjacency Matrix, but for a sparse graph an Adjacency List is more efficient. Adjacency List An Adjacency List is usually represented as a HashTable (or an Array) where an entry at `u` contains a Linked List. The Linked List contains `v` and optionally another parameter `w`. Here `u` and `v` are node(or vertex) labels and `w` is the weight of the edge. By Traversing the linked list we obtain the immediate neighbours of `u`. Visually, it looks like this. For implementing this in Python, we'll be using the dict()  for the main HashTable. For the Linked List we can use a list of 2 sized tuples (v,w).  Sidenote: Instead of a list of tuples, you can use a dict(), ...